# -*- coding: UTF-8 -*-
# Announces the first two columns in the list of torrents.
# The visible text on the two columns are announced.
# by Marcos Antonio de Oliveira <mao-mail@uol.com.br>
import appModuleHandler
import displayModel
import controlTypes
import re
import winUser
import ui
import api
import addonHandler
import NVDAObjects
#initialize translation
addonHandler.initTranslation()

class AppModule(appModuleHandler.AppModule):
	def event_NVDAObject_init(self,obj):
		if obj.windowControlID == 27 and obj.role == controlTypes.ROLE_LIST:
			#translators: this message announces list of torrents control.
			obj.name = _('List of torrents')
		elif obj.windowControlID == 30 and obj.role == controlTypes.ROLE_LIST and obj.windowClassName == 'SysListView32':
						#translators: this message announces list of content of torrents control.
			obj.name = _('List of content torrents')
		if obj.windowClassName == 'SysListView32' and obj.role == controlTypes.ROLE_LISTITEM and obj.windowControlID == 27:
			# Checking if there is value for the column name.
			if obj.children[1].name:
				return
			# Taking the coordinates of the first two columns of the list view header.
			# col1 is N.
			# col2 is name of torrent.
			hHeader = winUser.getWindow(obj.parent.windowHandle, 5)
			header = NVDAObjects.IAccessible.getNVDAObjectFromEvent(hHeader, -4, 0)
			col1 = header.children[0]
			col2 = header.children[1]
			leftCol1 = col1.location[0]
			rightCol1 =col1.location[2]
			leftCol2 = col2.location[0]
			rightCol2  = col2.location[2]
			# Getting the visible text, using as a basis the coordinates of the columns.
			n = displayModel.getWindowTextInRect (obj.appModule.helperLocalBindingHandle, obj.windowHandle, leftCol1, obj.location[1], rightCol1 + leftCol1, obj.location[1]+obj.location[3],1,1)[0]
			name = displayModel.getWindowTextInRect (obj.appModule.helperLocalBindingHandle, obj.windowHandle, leftCol2, obj.location[1], rightCol2 + leftCol2, obj.location[1] + obj.location[3],displayModel.DisplayModelTextInfo.minHorizontalWhitespace, displayModel.DisplayModelTextInfo.minVerticalWhitespace)[0]
			if (not name  or   name.isspace()) and (not n or   n.isspace()):
				return
			pat = re.compile('>(.+)<')
			name = re.findall(pat,name)[0]
			if n and not n.isspace():
				n = re.findall(pat, n)[0]
			else:
				n = ''
			obj.name = '%s: %s; %s: %s; %s' %(col1.name, n, col2.name, name, obj.name)

